using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using Syncfusion.Windows.Forms.HTMLUI;

namespace LoadImageFromResource
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Stream imageStream = null;

        private void Form1_Load(object sender, EventArgs e)
        {
            this.htmluiControl2.LoadHTML(@"..\..\imgDoc.htm");
            string htmlDoc = this.htmluiControl2.Document.Document.OuterXml.ToString();

            Console.WriteLine(htmlDoc.ToString());
            this.htmluiControl1.LoadFromString(htmlDoc);            
        }

        private void htmluiControl1_LoadFinished(object sender, EventArgs e)
        {
            Image img = Image.FromStream(GetImageStream());
            imageStream.Close();
            this.pictureBox1.Image = img;
            this.pictureBox1.Show();
            this.pictureBox1.Visible = true;
        }

        private void htmluiControl1_PreRenderDocument(object sender, PreRenderDocumentArgs e)
        {
            Hashtable htmlelements = new Hashtable();
            htmlelements = e.Document.ElementsByUserID;
            BaseElement picBox = htmlelements["img"] as BaseElement;
            new CustomControlBase(picBox, this.pictureBox1);
        }

        private void htmluiControl2_LoadFinished(object sender, EventArgs e)
        {
            RefreshDocument(this.htmluiControl2.Document);
        }

        private void RefreshDocument(IInputHTML document)
        {
            //Getting all the elements in the document named "body"
            IHTMLElement[] body = document.GetElementsByName("body");

            //Getting the child elements of the body element in the element's collection
            IHTMLElementsCollection elem = body[0].Children;

            foreach (BaseElement child in elem)
            {
                //searching for the children containing the ImageFromStream attribute
                if ((child.Attributes.Contains("ImageFromStream") == true) && (child is IMGElementImpl))
                {
                    AddIDAttr(child);
                }
            }
        }

        private void AddIDAttr(BaseElement elem)
        {
            //Setting the value of the image attribute
            if (elem.Attributes.Contains("id") == false)
            {
                elem.Attributes.Add("id");
            }
            elem.Attributes["id"].Value = "img";
            elem.Parent.Control.Document.RenderRoot.Attributes["topMargin"].Value = Convert.ToString(5);
        }

        private Stream GetImageStream()
        {
            //Getting the stream of image from the resource
            Assembly assembly = Assembly.GetExecutingAssembly();
            imageStream = assembly.GetManifestResourceStream("LoadImageFromResource.image.bmp");
            return imageStream;
        }
    }
}